import * as React from 'react'
import * as Navi from 'navi'

import { imports } from './imports'

const getPageContent = (filepath) => async () => {
  // tslint:disable-next-line
  const importFn = imports[filepath]
  const { default: Component, getInitialData } = await importFn()
  let data;
  let error;

  try {
    data = getInitialData && (await getInitialData())
    error = null
  } catch(err) {
    console.error(err)
    data = {}
    error = err
  }

  return {
    Component,
    data,
    error,
    filepath
  }
}

export default Navi.createSwitch({
  paths: {
    <% entries.forEach(function(entry) { %>'<%- entry.route %>': Navi.createPage({
      title: '<%- entry.name %>',
      getContent: getPageContent('<%- entry.filepath %>')
    }),<% }) %>
  },
})
